hdu 6073

  题意: 给出一个二部图,U、V分别是二部图的两个点集,其中,U中每个点会有两条边连到V中两个不同的点。

  完美匹配定义为:所有点都成功匹配。

  思路:已知一定是完美匹配了呀(也一定存在),我们先把度数为一的匹配了(用拓扑把读书为一的找出来),那么剩下的图中左右各有m个点,每个点度数都不小于2,且左边每个点度数都是2,而右侧总度数是2m,因此右侧只能是每个点度数都是2。这说明这个图每个连通块是个环,在环上间隔着取即可,一共两种方案。

   然后就完了(还是看了别人的才懂得ε=ε=ε=┏(゜ロ゜;)┛)。
/*  gyt
       Live up to every day            */
#include<cstdio>
#include<cmath>
#include<iostream>
#include<algorithm>
#include<vector>
#include<stack>
#include<cstring>
#include<queue>
#include<set>
#include<string>
#include<map>
#include <time.h>
#define PI acos(-1)
using namespace std;
typedef long long ll;
typedef double db;
const int maxn = 6e5+10;
const int maxm=5000+10;
const ll mod = 998244353;
const int INF = 0x3f3f3f;
const db eps = 1e-9;
struct node {
    ll w;
    int v, next;
}edge[maxn<<1];
int no, head[maxn];
int bad[maxn], deg[maxn], vis[maxn];
int n, nn;
queue<int>q;
vector<int>vtt;
ll ans, must;

void init() {
    no=0;
    memset(vis, 0, sizeof(vis));
    memset(head, -1, sizeof(head));
    memset(bad, 0, sizeof(bad));
    memset(deg, 0, sizeof(deg));
}
void add(int u, int v, int w) {
    edge[no].v=v; edge[no].next=head[u];
    edge[no].w=w; head[u]=no++;
}
ll dfs(int cur, int father)  {
    vtt.push_back(cur);
    vis[cur] = 1;
    for(int k = head[cur], kk; k != -1; k = edge[k].next)   {
        int v = edge[k].v;
        if(v == father) continue;
        if(bad[v] || vis[v]) continue;
        vis[v] = 1; vtt.push_back(v);
        for(kk = head[v]; kk != -1; kk = edge[kk].next) {
            if(!bad[edge[kk].v] && edge[kk].w != cur)
                break;
        }
        return dfs(edge[kk].v, v)*edge[k].w%mod;
    }
    return 1;
}
void solve() {
    init();  scanf("%d", &n);
    nn=n*2;
    for (int i=1; i<=n; i++) {
        int v, w;  scanf("%d%d", &v, &w);
        add(i, n+v, w);  add(n+v, i, w);
        deg[i]++, deg[n+v]++;
        scanf("%d%d", &v, &w);
        add(i, n+v, w);  add(n+v, i, w);
        deg[i]++, deg[n+v]++;
    }
    must=1;
    while(!q.empty())  q.pop();
    for (int i=1; i<=n; i++) {
        if (deg[n+i]==1)  q.push(n+i);  //把度数为一的提出来
    }
    while(!q.empty()) {
        int u=q.front();  q.pop();
        bad[u]=1;
        for (int k=head[u]; ~k; k=edge[k].next) {   //找到度数为一的点连的另一个点a
            int v=edge[k].v;
            if (bad[v])  continue;
            must=must*edge[k].w%mod;
            bad[v]=1;
            for (int kk=head[v]; ~kk; kk=edge[kk].next) {//把a相连的点找出来,如果减掉1还是1,说明他能匹配的也只能是一个
                if (bad[edge[kk].v])  continue;if (--deg[edge[kk].v]==1)  {
                    q.push(edge[kk].v);
                }
            }
        }
    }
    ans=must;
    //cout<<ans<<endl;
    for (int i=1; i<=n; i++) {
        if (vis[i]||bad[i])  continue;
        ll ans1=0;
        for(int k = head[i], kk; k != -1; k = edge[k].next) {//分别两种匹配的结果
            int v=edge[k].v;
            vtt.clear();
            vis[v]=1;
            for ( kk=head[v]; ~kk; kk=edge[kk].next) {
                if (!bad[edge[kk].v] && edge[kk].v!=i)  break;
            }
            ans1=(ans1+dfs(edge[kk].v, v)*edge[k].w%mod)%mod;
           // cout<<ans1<<endl;
            vis[v]=0;
            for (int j=0; j<vtt.size(); j++) {
                vis[vtt[j]]=0;
            }
            vtt.push_back(v);
        }
        for (int j=0; j<vtt.size(); j++) {
            vis[vtt[j]]=1;
        }
        ans = ans*ans1%mod;
    }
    printf("%lld\n", ans);
}
int main() {
    int t = 1;
    //freopen("in.txt", "r", stdin);
    //freopen("out.txt", "w", stdout);
    scanf("%d", &t);
    while(t--)
        solve();
    return 0;
}
 
时间: 2024-10-05 06:38:48

hdu 6073的相关文章

HDU 6073 Matching In Multiplication dfs遍历环 + 拓扑

Matching In Multiplication Problem DescriptionIn the mathematical discipline of graph theory, a bipartite graph is a graph whose vertices can be divided into two disjoint sets U and V (that is, U and V are each independent sets) such that every edge

HDU 6073 Matching In Multiplication —— 2017 Multi-University Training 4

Matching In Multiplication Time Limit: 6000/3000 MS (Java/Others)    Memory Limit: 524288/524288 K (Java/Others)Total Submission(s): 1389    Accepted Submission(s): 423 Problem Description In the mathematical discipline of graph theory, a bipartite g

HDU 6073 Matching In Multiplication(拓扑排序)

Matching In Multiplication Time Limit: 6000/3000 MS (Java/Others)    Memory Limit: 524288/524288 K (Java/Others)Total Submission(s): 1127    Accepted Submission(s): 325 Problem Description In the mathematical discipline of graph theory, a bipartite g

HDU 6203 ping ping ping [LCA,贪心,DFS序,BIT(树状数组)]

题目链接:[http://acm.hdu.edu.cn/showproblem.php?pid=6203] 题意 :给出一棵树,如果(a,b)路径上有坏点,那么(a,b)之间不联通,给出一些不联通的点对,然后判断最少有多少个坏点. 题解 :求每个点对的LCA,然后根据LCA的深度排序.从LCA最深的点对开始,如果a或者b点已经有点被标记了,那么continue,否者标记(a,b)LCA的子树每个顶点加1. #include<Bits/stdc++.h> using namespace std;

HDU 5542 The Battle of Chibi dp+树状数组

题目:http://acm.hdu.edu.cn/showproblem.php?pid=5542 题意:给你n个数,求其中上升子序列长度为m的个数 可以考虑用dp[i][j]表示以a[i]结尾的长度为j的上升子序列有多少 裸的dp是o(n2m) 所以需要优化 我们可以发现dp的第3维是找比它小的数,那么就可以用树状数组来找 这样就可以降低复杂度 #include<iostream> #include<cstdio> #include<cstring> #include

hdu 1207 汉诺塔II (DP+递推)

汉诺塔II Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 4529    Accepted Submission(s): 2231 Problem Description 经典的汉诺塔问题经常作为一个递归的经典例题存在.可能有人并不知道汉诺塔问题的典故.汉诺塔来源于印度传说的一个故事,上帝创造世界时作了三根金刚石柱子,在一根柱子上从下往

[hdu 2102]bfs+注意INF

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=2102 感觉这个题非常水,结果一直WA,最后发现居然是0x3f3f3f3f不够大导致的--把INF改成INF+INF就过了. #include<bits/stdc++.h> using namespace std; bool vis[2][15][15]; char s[2][15][15]; const int INF=0x3f3f3f3f; const int fx[]={0,0,1,-1};

HDU 3555 Bomb (数位DP)

数位dp,主要用来解决统计满足某类特殊关系或有某些特点的区间内的数的个数,它是按位来进行计数统计的,可以保存子状态,速度较快.数位dp做多了后,套路基本上都差不多,关键把要保存的状态给抽象出来,保存下来. 简介: 顾名思义,所谓的数位DP就是按照数字的个,十,百,千--位数进行的DP.数位DP的题目有着非常明显的性质: 询问[l,r]的区间内,有多少的数字满足某个性质 做法根据前缀和的思想,求出[0,l-1]和[0,r]中满足性质的数的个数,然后相减即可. 算法核心: 关于数位DP,貌似写法还是

HDU 5917 Instability ramsey定理

http://acm.hdu.edu.cn/showproblem.php?pid=5917 即世界上任意6个人中,总有3个人相互认识,或互相皆不认识. 所以子集 >= 6的一定是合法的. 然后总的子集数目是2^n,减去不合法的,暴力枚举即可. 选了1个肯定不合法,2个也是,3个的话C(n, 3)枚举判断,C(n, 4), C(n, 5) #include <bits/stdc++.h> #define IOS ios::sync_with_stdio(false) using name